package com.vcarecity.publish.aop;

import com.vcarecity.publish.annotation.SkipMethod;
import com.vcarecity.publish.api.ApiResult;
import com.vcarecity.publish.controller.PrepareController;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Pointcut;
import org.aspectj.lang.reflect.MethodSignature;
import org.springframework.stereotype.Component;

import java.lang.reflect.Method;

/**
 * @author VcKerry on 12/20/19
 */

@Aspect
@Component
public class PrepareAopController {


    @Pointcut("execution(public * com.vcarecity.publish.controller.*.*(..))")
    public void preparePointcut() {

    }


    @Around("preparePointcut()")
    public Object check(ProceedingJoinPoint pjp) throws Throwable {

        Object target = pjp.getTarget();
        if (target instanceof PrepareController) {
            MethodSignature signature = (MethodSignature) pjp.getSignature();
            Method method = signature.getMethod();
            if (method.getAnnotation(SkipMethod.class) != null) {
                return pjp.proceed();
            }

            PrepareController o = (PrepareController) target;
            if (o.isLoadData()) {
                return pjp.proceed();
            } else {
                return ApiResult.builder().status(40000).message("data not loaded").build();
            }
        }
        return pjp.proceed();
    }
}
