package com.vcarecity.publish.elastic.service;

import java.io.IOException;
import java.util.List;

/**
 * @author kerryzhang on 2019/12/17
 */

public interface ElasticIndexService {

    /**
     * index 是否存在
     * <a href="https://www.elastic.co/guide/en/elasticsearch/client/java-rest/current/java-rest-high-indices-exists.html">
     * API
     * </a>
     *
     * @param index
     * @return
     * @throws IOException
     */
    boolean indexExist(String index) throws IOException;

    /**
     * create index
     *
     * @param indices
     * @return
     * @throws IOException
     */
    boolean createIndex(String indices) throws IOException;

    /**
     * delete index
     *
     * <a href="https://www.elastic.co/guide/en/elasticsearch/client/java-rest/current/java-rest-high-delete-index.html">
     * API
     * </a>
     *
     * @param indices
     * @throws IOException
     */
    void deleteIndex(String... indices) throws IOException;


    /**
     * list index
     *
     * @return
     */
    List<String> indices();

}
