package com.vcarecity.publish.service;

/**
 * @author VcKerry on 12/26/19
 */

public interface LoadDataStatusService {

    /**
     * 数据未加载
     */
    int DATA_STATUS_NOT_LOAD = -1;
    /**
     * 数据加载中
     */
    int DATA_STATUS_LOADING = 0;
    /**
     * 数据加载完成
     */
    int DATA_STATUS_LOADED = 1;


    /**
     * 获取当前状态
     *
     * @return
     */
    int getStatus();

    /**
     * 已经加载过了?
     *
     * @return
     */
    default boolean isLoaded() {
        return getStatus() == DATA_STATUS_LOADED;
    }

    /**
     * set status
     *
     * @param newStatus
     */
    void setStatus(int newStatus);

    /**
     * set loaded
     */
    default void setLoaded() {
        setStatus(DATA_STATUS_LOADED);
    }

}
