package com.vcarecity.publish.util;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author VcKerry on 12/19/19
 */

public class ObjectFieldToMap {

    private static Map<Class<?>, String[]> fieldCache = new HashMap<>();


    public static String[] getField(Class<?> cls) {

        String[] fields = fieldCache.get(cls);

        if (fields != null) {
            return fields;
        }

        Class<?> clazz = cls;

        List<String> fieldList = new ArrayList<>();
        while (clazz != Object.class) {
            Field[] declaredFields = clazz.getDeclaredFields();
            for (Field declaredField : declaredFields) {
                fieldList.add(declaredField.getName());
            }
            clazz = clazz.getSuperclass();
        }
        String[] strings = fieldList.toArray(new String[]{});
        fieldCache.put(cls, strings);
        return strings;
    }

}
