package com.vcarecity.publish.util;

import java.io.File;
import java.io.IOException;
import java.nio.file.FileSystemNotFoundException;
import java.nio.file.Files;
import java.util.List;

/**
 * @author VcKerry on 12/19/19
 */

public class Utils {

    public static final int[] EMPTY_PARAM = new int[0];

    public static int[] paramToArray(String input) {
        if (input == null) {
            return EMPTY_PARAM;
        }
        input = input.trim();
        if (input.length() == 0) {
            return EMPTY_PARAM;
        }

        String[] split = input.split(",");
        if (split.length == 0) {
            return EMPTY_PARAM;
        }
        int[] res = new int[split.length];
        for (int i = 0; i < split.length; i++) {
            res[i] = Integer.parseInt(split[i]);
        }
        return res;
    }


    public static String readFile(String filePath) throws IOException {
        return readFile(new File(filePath));
    }

    public static String readFile(File file) throws IOException {
        if (!file.exists()) {
            throw new FileSystemNotFoundException(file.getAbsolutePath());
        }
        List<String> strings = Files.readAllLines(file.toPath());
        return String.join("\n", strings);
    }


}
